#include "AttrSet.h"
#include "AttrSetType.h"
#include "AttrType.h"
#include "GraphManager.h"
#include "DomainModel.h"


AttrSet::AttrSet(): type (GraphManager::getInstance()->getDomainModel()->getUnknownType()), modified(FALSE)
{   }
  


AttrSet::~AttrSet()
{  }

void AttrSet::del(const char* name) 	
{					//!!!!STILL TO DO:
   if (!name) attrs.Flush();		//Must not delete those attrs whose names are
   else 				//present in the current AttrSetType
   for(int i=attrs.Count()-1;i>=0;i--)
       if (attrs[i].name==name)
       {
	   attrs.Delete(i);
  	   return;
       }
}





void AttrSet::setType(const AttrSetType* t)		

//Associates a new AttrSetType with this.
//The effect of this operation is to add to this attributes with the names in 
//its new AttrSetType. Semantically, this is not different than adding those
//attributes later when we really want to give them values, too. However, by 
//specifying the AttrSetType, this can efficiently share the attr-names with 
//those from the AttrSetType, which is an important memory advantage. 
{						
   if (type==t) return;				//don't do work uselessly

   int i;
   if (type)					//if this has a type set, delete
      for(i=0;i<type->numAttrTypes();i++)	//all attrs that were belonging to that
         del(type->getAttrType(i)->getName());	//type, since the type will be changed
     

   for(i=0;i<t->numAttrTypes();i++)		//add attrs for all attr-types of the new type:	
   {						
      const AttrType* at = t->getAttrType(i);   //get attr-type
      const char*     nm = at->getName();	
   
      del(nm);					//del any existing attr with identical name
      attrs.Add(Item(nm)); 			//add new attr with that name taking care to 
   }                 				//share its name-string with that in AttrSetType

   type = t;					//register AttrSetType as this's type
}
