#include "BottomUpSelection.h"
#include "GraphManager.h"
#include "SelList.h"
#include "Node.h"
#include "Edge.h"
#include <stdlib.h>
#include <iostream.h>


static int BottomUpSelection::compare_nodes(const void* a1,const void* a2)	//Needed by qsort() to sort Nodes
{								
   Node* n1 = *(Node**)a1;
   Node* n2 = *(Node**)a2;
   return n1->getFloat(attr) - n2->getFloat(attr);
}


static int compare_edges(const void* a1,const void* a2)		//Edges are sorted in level-order by comparing
{								//the levels of their 'from' nodes. This will make
   Edge* e1 = *(Edge**)a1;					//a vedge's level == the level of its 'superior' node,
   Edge* e2 = *(Edge**)a2;					//so a vedge L1->L2 will always come later in the sorted list as
   return e1->fromNode()->getFloat(attr) - 
          e2->fromNode()->getFloat(attr);	//a hedge that is into the level L2. Which is what we want. 
}   


BottomUpSelection::BottomUpSelection(Selection* s,Selection* res)
{  
   void** arr = new void*[s->numNodes()]; int k,c=0;		//Allocate array for qsort()
   
   Selection::NodeIterator* i = s->iterNodes();			//Copy Nodes in input-sel into array
   for(Node* n;(n=i->next());)
      arr[c++] = n;

   qsort(arr,c,sizeof(void**),compare_nodes);			//Sort Nodes in increasing level order
   for(k=0;k<c;k++)						//...and copy them as such into this
      res->addNode((Node*)arr[k]);
   delete[] arr;						//Done with Nodes-array

   arr = new void*[s->numEdges()]; c=0;				//Copy Edges in input-sel into array
   Selection::EdgeIterator* j = s->iterEdges();
   for(Edge* e;(e=j->next());)
      arr[c++] = e;

   qsort(arr,c,sizeof(void*),compare_edges);			//Sort Edges in increasing level-order
   for(k=0;k<c;k++)						//...and copy them as such into this
      res->addEdge((Edge*)arr[k]);
   delete[] arr;
}


