% -*- Prolog -*-

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% demi_abs.pl - abstractions for Demi
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%% Main logical view %%%%
contain('ISA_UI', 'ISA_UI_PLATFORM').

contain('ISA_UI_PLATFORM', 'Native_Inhouse_Apps').
contain('ISA_UI_PLATFORM', 'ServicesAndConnectivity').

contain('Native_Inhouse_Apps', 'Organizer').

contain('Native_Inhouse_Apps', 'Phonebook').
contain('Phonebook', 'Phonebook_common').
contain('Phonebook', 'Phonebook_GSM').

contain('Native_Inhouse_Apps', 'PersonalApps').

contain('Native_Inhouse_Apps', 'SIM_UI').
%contain('SIM_UI', 'SIM_UI_common'). empty at the moment
contain('SIM_UI', 'SIM_UI_GSM').

contain('Native_Inhouse_Apps', 'Connectivity').
contain('Connectivity','Connectivity_common').
contain('Connectivity','Connectivity_GSM').

contain('Native_Inhouse_Apps', 'Messaging').
contain('Messaging', 'Messaging_common').
contain('Messaging', 'Messaging_GSM').

contain('Native_Inhouse_Apps', 'Call_Network').
contain('Call_Network', 'Call_Network_GSM').
contain('Call_Network', 'Call_Network_common').

contain('Native_Inhouse_Apps', 'Games').

contain('Native_Inhouse_Apps', 'CoreApps').
contain('CoreApps', 'CoreApps_common').
contain('CoreApps', 'CoreApps_GSM').

contain('Native_Inhouse_Apps', 'AudioAndVoice').
contain('AudioAndVoice', 'AudioAndVoice_common').
contain('AudioAndVoice', 'AudioAndVoice_GSM').

contain('Native_Inhouse_Apps', 'Security').
contain('Security', 'Security_GSM').

contain('Native_Inhouse_Apps', 'SpeechCodec_GSM').

contain('ServicesAndConnectivity','EndUserServices').
contain('ServicesAndConnectivity','InputOutputServices').
contain('ServicesAndConnectivity','UserDataExchange').

contain('ServicesAndConnectivity', 'CoreServices').
contain('CoreServices', 'CoreServices_common').
contain('CoreServices', 'CoreServices_GSM').

contain('UserDataExchange', 'GPRS').

%%%% Abstractions %%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% ISA UI PLATFORM %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%% Native In House Apps %%%%%%%%%%%%%%

%%%%%Organiser%%%%%%%%%
contain('Organizer', X) :- transitive_closure_refl(contain_dir,'/isa_ui/isa_ui_common/appls/calendar',X).
contain('Organizer','/isa_ui/isa_ui_common/appls/alarm').
contain('Organizer','/isa_ui/isa_ui_common/appls/todo').
contain('Organizer', X) :- transitive_closure_refl(contain_dir,'/isa_ui/isa_ui_common/appls/reminder',X).

%%%%%Phonebook%%%%%%%%%
contain('Phonebook_common', X) :- transitive_closure_refl(contain_dir,'/isa_ui/isa_ui_common/appls/phonebook',X).

%%%%%%PersonalApps%%%%%%%
contain('PersonalApps','/isa_ui/isa_ui_common/appls/calculator').
contain('PersonalApps','/isa_ui/isa_ui_common/appls/displaycontrast').
contain('PersonalApps','/isa_ui/isa_ui_common/appls/user_welcome_note').
contain('PersonalApps','/isa_ui/isa_ui_common/appls/ota_operator_logo').
contain('PersonalApps','/isa_ui/isa_ui_common/appls/ota_rt').
contain('PersonalApps','/isa_ui/isa_ui_common/appls/count_down_timer').
contain('PersonalApps','/isa_ui/isa_ui_common/appls/stopwatch').
contain('PersonalApps','/isa_ui/isa_ui_common/appls/ota_synch_settings').
contain('PersonalApps','/isa_ui/isa_ui_common/appls/ota_ppc').
contain('PersonalApps','/isa_ui/isa_ui_common/appls/vcalsend').

%%%%%%SIM UI %%%%%%%%%%%
%contain('SIM_UI','/isa_ui/isa_ui_common/appls/count_down_timer').

%%%%%% Connectivity %%%%%%
contain('Connectivity_common','/isa_ui/isa_ui_common/appls/ir_control').
contain('Connectivity_common','/isa_ui/isa_ui_common/appls/syncml').
contain('Connectivity_common','/isa_ui/isa_ui_common/appls/acc').
contain('Connectivity_common','/isa_ui/isa_ui_common/appls/accessory_settings').
contain('Connectivity_common','/isa_ui/isa_ui_common/appls/bluetooth').

%%%%%% CoreApps %%%%%%
contain('CoreApps_common','/isa_ui/isa_ui_common/appls/help').
contain('CoreApps_common','/isa_ui/isa_ui_common/appls/power').
contain('CoreApps_common','/isa_ui/isa_ui_common/appls/field_test_display').
contain('CoreApps_common','/isa_ui/isa_ui_common/appls/keyguard').
contain('CoreApps_common','/isa_ui/isa_ui_common/appls/langsel').
contain('CoreApps_common','/isa_ui/isa_ui_common/appls/em').
contain('CoreApps_common','/isa_ui/isa_ui_common/appls/rtc').
contain('CoreApps_common','/isa_ui/isa_ui_common/appls/startup').
contain('CoreApps_common','/isa_ui/isa_ui_common/appls/sw_version_display').
contain('CoreApps_common','/isa_ui/isa_ui_common/appls/rssi').
contain('CoreApps_common','/isa_ui/isa_ui_common/appls/wap_homepage_shortcut').
contain('CoreApps_common','/isa_ui/isa_ui_common/appls/vvol').
contain('CoreApps_common','/isa_ui/isa_ui_common/appls/wrm').
contain('CoreApps_common','/isa_ui/isa_ui_common/appls/rfs').
contain('CoreApps_common','/isa_ui/isa_ui_common/appls/nitz').

%%%%%% AudioAndVoice %%%%%%
contain('AudioAndVoice_common','/isa_ui/isa_ui_common/appls/radio').
contain('AudioAndVoice_common','/isa_ui/isa_ui_common/appls/equalizer').
contain('AudioAndVoice_common', X) :- transitive_closure_refl(contain_dir,'/isa_ui/isa_ui_common/appls/voice',X).
contain('AudioAndVoice_common','/isa_ui/isa_ui_common/appls/upf').
contain('AudioAndVoice_common','/isa_ui/isa_ui_common/appls/audio_test_activation').

contain('Call_Network_common','/isa_ui/isa_ui_common/appls/gprs_control').
contain('Call_Network_common','/isa_ui/isa_ui_common/appls/packet_data_counter').
contain('Call_Network_common','/isa_ui/isa_ui_common/appls/gprs_indicator').
contain('Call_Network_common','/isa_ui/isa_ui_common/appls/gprs_dialup').

contain('Messaging_common', X) :- transitive_closure_refl(contain_dir,'/isa_ui/mms',X).

contain('Games','/games/configuration_info').


%%%%%%%%%%% Services and Connectivity %%%%%%%
%%%%%% User Data Exchange %%%%%%
contain('GPRS', X) :- transitive_closure_refl(contain_dir,'/cs.isa2/cs_gprs',X).
contain('GPRS', X) :- transitive_closure_refl(contain_dir,'/ds_gprs',X).

%%%%%% End-User Services %%%%%%%%
contain('EndUserServices','/isa_ui/isa_ui_common/servers/calendar').
contain('EndUserServices','/isa_ui/isa_ui_common/servers/phonebook').
contain('EndUserServices','/isa_ui/isa_ui_common/servers/todo').
contain('EndUserServices','/isa_ui/isa_ui_common/servers/garbage').

%%%%%% Input Output Services %%%%%
contain('InputOutputServices','/isa_ui/isa_ui_common/servers/voice').
contain('InputOutputServices', X) :- transitive_closure_refl(contain_dir,'/isa_ui/isa_ui_platform/servers/menu',X).
contain('InputOutputServices','/isa_ui/isa_ui_common/servers/panel').
contain('InputOutputServices','/isa_ui/isa_ui_common/servers/upf').
contain('InputOutputServices','/isa_ui/isa_ui_common/servers/tone').
contain('InputOutputServices', X) :- transitive_closure_refl(contain_dir,'/isa_ui/isa_ui_platform/config',X).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% ISA UI GSM %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%% Apps %%%%%%%%%%%%%%%%%%
contain('Call_Network_GSM','/isa_ui/isa_ui_gsm/appls/call').
contain('Call_Network_GSM','/isa_ui/isa_ui_gsm/appls/call_timer').
contain('Call_Network_GSM','/isa_ui/isa_ui_gsm/appls/emerg_deleg').
contain('Call_Network_GSM','/isa_ui/isa_ui_gsm/appls/network_select').

contain('Connectivity_GSM','/isa_ui/isa_ui_gsm/appls/gprs_control').
contain('Connectivity_GSM','/isa_ui/isa_ui_gsm/appls/gprs_dialup').
contain('Connectivity_GSM','/isa_ui/isa_ui_gsm/appls/packet_data_counter').
contain('Connectivity_GSM','/isa_ui/isa_ui_gsm/appls/aoc').

contain('SIM_UI_GSM','/isa_ui/isa_ui_gsm/appls/homezone').
contain('SIM_UI_GSM', X) :- transitive_closure_refl(contain_dir,'/isa_ui/isa_ui_gsm/appls/simatk',X).
contain('SIM_UI_GSM','/isa_ui/isa_ui_gsm/appls/simlock').

contain('Security_GSM','/isa_ui/isa_ui_gsm/appls/security').
contain('Security_GSM','/isa_ui/isa_ui_gsm/appls/sec_change').
contain('Security_GSM','/isa_ui/isa_ui_gsm/appls/sec_level').
contain('Security_GSM','/isa_ui/isa_ui_gsm/appls/sec_query').
contain('Security_GSM','/isa_ui/isa_ui_gsm/appls/sec_key').

%contain('Phonebook','/isa_ui/isa_ui_gsm/appls/mcopy').
%contain('Phonebook','/isa_ui/isa_ui_gsm/appls/mcopyone').
%contain('Phonebook','/isa_ui/isa_ui_gsm/appls/mselect').
contain('Phonebook_GSM', X) :- transitive_closure_refl(contain_dir,'/isa_ui/isa_ui_gsm/appls/phonebook',X).

contain('Messaging_GSM','/isa_ui/isa_ui_gsm/appls/mcn').
contain('Messaging_GSM','/isa_ui/isa_ui_gsm/appls/sms').
contain('Messaging_GSM','/isa_ui/isa_ui_gsm/appls/smscb').
contain('Messaging_GSM','/isa_ui/isa_ui_gsm/appls/smsdl').
contain('Messaging_GSM','/isa_ui/isa_ui_gsm/appls/smsmo').
contain('Messaging_GSM','/isa_ui/isa_ui_gsm/appls/smsmt').
contain('Messaging_GSM','/isa_ui/isa_ui_gsm/appls/smssett').
contain('Messaging_GSM','/isa_ui/isa_ui_gsm/appls/autosms').

contain('CoreApps_GSM','/isa_ui/isa_ui_gsm/appls/swversion_imei_display').
contain('CoreApps_GSM','/isa_ui/isa_ui_gsm/appls/u9_endkey').
contain('CoreApps_GSM','/isa_ui/isa_ui_gsm/appls/cipher').
contain('CoreApps_GSM','/isa_ui/isa_ui_gsm/appls/gms').
contain('CoreApps_GSM','/isa_ui/isa_ui_gsm/appls/ussd').
contain('CoreApps_GSM','/isa_ui/isa_ui_gsm/appls/vmbx').
contain('CoreApps_GSM','/isa_ui/isa_ui_gsm/appls/ss').
contain('CoreApps_GSM','/isa_ui/isa_ui_gsm/appls/clear_blacklist').
contain('CoreApps_GSM','/isa_ui/isa_ui_gsm/appls/als').
contain('CoreApps_GSM','/isa_ui/isa_ui_gsm/appls/ctn').
contain('CoreApps_GSM','/isa_ui/isa_ui_gsm/appls/ond').

contain('AudioAndVoice_GSM','/isa_ui/isa_ui_common/appls/wakeuptone').

contain('SpeechCodec_GSM','/isa_ui/isa_ui_gsm/appls/speech_codec').

%%%%%%%% Services %%%%%%%%%%%%%

contain('CoreServices_GSM','/isa_ui/isa_ui_gsm/servers/aoc').
contain('CoreServices_GSM','/isa_ui/isa_ui_gsm/servers/bearerctrl').
contain('CoreServices_GSM','/isa_ui/isa_ui_gsm/servers/call').
contain('CoreServices_GSM','/isa_ui/isa_ui_gsm/servers/security').
contain('CoreServices_GSM','/isa_ui/isa_ui_gsm/servers/sms_memory').

%%%%%%%%%%%% core_sw %%%%%%%%%%%%%%%%%%%%%%

contain('CoreServices_common', X) :- transitive_closure_refl(contain_dir,'/coresw/servers',X).
contain('CoreServices_common','/isa_ui/isa_ui_common/servers/bearerctrl').
contain('CoreServices_common','/isa_ui/isa_ui_gsm/servers/simatk').
contain('CoreServices_common','/isa_ui/isa_ui_gsm/servers/ss').

%The next line is due to a bug in the model
contain('CoreServices_common', X) :- transitive_closure_refl(contain_dir,'/coresw/cl/cm/config',X).
contain('CoreServices_common', X) :- transitive_closure_refl(contain_dir,'/coresw/em',X).

%SIM
contain('SIM', X) :- transitive_closure_refl(contain_dir,'/sim',X).

%WAVE
contain('WAVE', X) :- transitive_closure_refl(contain_dir,'/wave',X).

%GPRS

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%% Print the TCL commands %%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

is_parent(X,Y) :- contain(X,Y).
is_type(X,'Subsystem') :- contain(X,_).

:- printTCLCommands.
