pr_domain_load_rsf DATA3
pr_load DATA3/cream_componentView.rsf

pr_sel_new tree
pr_sel_new hl_sel
pr_sel_new hl_sel2
pr_sel_new nested_sel
pr_sel_new vis_tree


#  Select separately the "level" arcs
#-------------------------------------------------------------------
pr_filter_edges_by_type All level {level}

# Make a fake "level" attribute, we'll use it in the nested-layout...
#-----------------------------------------------------------------------
set i [pr_selection [pr_get_selection name "level"] iter_edges]
set e [pr_iterator $i next_edge]
while {$e!=0} {
   pr_edge $e set "type" "level" string; set e [pr_iterator $i next_edge]
}

#!!!  
pr_sel_new full_tree  
set root [pr_selection [pr_sel_new] name]
pr_selection_roots [pr_get_selection name "level"] type "level" $root
pr_traverse_tree [pr_get_selection name "All"] [pr_get_selection name $root] type "level" "full_tree"
pr_selection [pr_get_selection name $root] delete
pr_compute_level [pr_get_selection name "full_tree"] "global_level" "type" "level" out

set s [pr_get_selection name "full_tree"]
set i [pr_selection $s iter_nodes]; set n [pr_iterator $i next_node]
while {$n!=0} {
   set l [pr_node $n attr "global_level"]
   if {$l<4} {pr_node $n set "open" 1 int} else {pr_node $n set "open" 0 int}
   set n [pr_iterator $i next_node]
}

pr_select_nodes_by_value "full_tree" "vis_tree" "open" 1




# Make several viewers for the data
#-------------------------------------------------------------------
pr_lay_dot -set ranksep 30 rankdir 1
pr_lay_dot      level 	 pos
pr_view_new vw  level 	 pos hl_sel
pr_view     vw  set   	 node_scale 0.02
pr_view     vw  set   	 user_cb my_vw1_cb 
pr_view     vw  set      render_2d true
pr_view     vw  set      sweep_cb my_sweep_cb
pr_view_new vw2 tree  	 pos2 hl_sel2
pr_view     vw2 set   	 output_only 1
pr_view     vw2 set      render_2d true
pr_view     vw2 set   	 user_cb my_vw2_cb
pr_view     vw2 set      sweep_cb my_sweep_cb 
pr_lay_dot      vis_tree pos3
pr_view_new vw3 vis_tree pos3 hl_sel3
pr_view     vw3 set   	 user_cb my_vw3_cb 
pr_view     vw3 set      render_2d true
pr_view     vw3 set      sweep_cb my_sweep_cb

#Callback for mouse-clicks in vw1: displays tree of the
#					     highlight-selection hl_sel in vw3
#----------------------------------------------------------------------------
proc my_vw1_cb {opt val} {
  #Treat only nodeclick and selection-events (no edgeclick events)
  #
  if {$opt=="edge"} { pr_gui:attrset_refresh_id .nodes $val; return }
  if {$opt=="node"} { pr_gui:attrset_refresh_id .nodes $val }

  #1. Select input_sel = hl_sel plus all edges between these nodes
  set input_sel [pr_selection [pr_sel_new] name]
  pr_selection_op edges hl_sel All $input_sel

  #2. Select root = root of input_sel via "level" arcs
  set root [pr_selection [pr_sel_new] name]
  pr_selection_roots [pr_get_selection name $input_sel] type "level" $root
  pr_selection [pr_get_selection name $input_sel] delete

  #3. Select tree = the full DAG from root via "level" arcs. Put tree also in hl_sel. 
  pr_traverse_dag [pr_get_selection name $root] type "level" "tree"
  pr_selection_op reunion "tree" "None" "hl_sel"

  #4. Extract a strict-tree 'stree' from the DAG, since we want a nested layout.
  #   Compute a level attribute "level_val", also for the nested layout
  set stree [pr_selection [pr_sel_new] name]
  pr_traverse_tree [pr_get_selection name "All"] [pr_get_selection name $root] type "level" $stree
  pr_selection [pr_get_selection name $root] delete
  pr_compute_level [pr_get_selection name $stree] "level_val" "type" "level"

  #5. Refresh viewer vw2 to show the strict tree 'stree'
  my_vw2_display $stree; pr_selection [pr_get_selection name $stree] delete
}  

#Callback for mouse-clicks in vw2: displays composite edges of the highlight-selection 
#---------------------------------------------------------------------------------------
proc my_vw2_cb {opt val} {
  #Treat only nodeclick and selection-events (no edgeclick events)
  #
  if {$opt=="edge"} { return }

  #1. Mark all composite-edges in nested_sel with attr "visible" depending on
  #   one of their end-nodes being in highlight-sel "hl_sel2"
  show_composite_edges "nested_sel" "hl_sel2"
  
  #2. Now update vw2 to show also the composite-edges from/to highlighted nodes
  pr_view vw2 touch
}  






# Glyph-proc for vw2
#
proc my_node_glyph {node} {
    set t [pr_node $node type]
    if {$t=="Interface"} {
       set r 1; set g 1; set b 0 
    } elseif {$t=="Application"} {
       set r 0; set g 1; set b 0
    } elseif {$t=="Server"} {
       set r 0; set g 0; set b 1 
    } elseif {$t=="Subsystem"} {
       set r 1; set g 0; set b 1
    } else {
       set r 1; set g 1; set b 1
    }    
    return [pr_make_cube color $r $g $b style lines]
}

# Glyph-proc for vw and vw3
#
proc my_node_glyph2 {node} {
    set t [pr_node $node type]
    if {$t=="Interface"} {
       set r 1; set g 1; set b 0 
    } elseif {$t=="Application"} {
       set r 0; set g 1; set b 0
    } elseif {$t=="Server"} {
       set r 0; set g 0; set b 1 
    } elseif {$t=="Subsystem"} {
       set r 1; set g 0; set b 1
    } else {
       set r 1; set g 1; set b 1
    }    
    return [pr_make_cube color $r $g $b] 
}

proc my_edge_glyph {e x y z} {
    set t [pr_edge $e type]
    if {$t=="level"} { 
       set r 1; set g 1; set b 0
    } elseif {$t=="composite"} {
	 set n1 [pr_edge $e node from]; set n2 [pr_edge $e node to]
	 if {[pr_node $n1 attr "level_val"]==[pr_node $n2 attr "level_val"]} {
          set r 0; set g 1; set b 0
       } else {
          if {[pr_edge $e attr "visible"]=="1"} {
             set r 1; set g 1; set b 1
          } else {
	      return  [pr_make_line edge $e x $x y $y z $z style invisible]
	    }
       }
    } else {
       set r 1; set g 1; set b 1
    } 
    return [pr_make_line edge $e x $x y $y z $z color $r $g $b $r $g $b] 
}

# Connect the glyph-procedures to glyph-mappers and then to viewers
#-------------------------------------------------------------------

pr_glyphs new IVTclNodeGlyphFactory my_node_mapper
pr_glyph_factory [pr_glyphs get node_glyph name my_node_mapper] set cb my_node_glyph
pr_view vw2 set node_glyph my_node_mapper

pr_glyphs new IVTclEdgeGlyphFactory my_edge_mapper
pr_glyph_factory [pr_glyphs get edge_glyph name my_edge_mapper] set cb my_edge_glyph
pr_view vw2 set edge_glyph my_edge_mapper

pr_glyphs new IVTclNodeGlyphFactory my_node_mapper2
pr_glyph_factory [pr_glyphs get node_glyph name my_node_mapper2] set cb my_node_glyph2
pr_view vw  set node_glyph my_node_mapper2
pr_view vw3 set node_glyph my_node_mapper2

#Procedure for building contents of vw2 - builds a nested layout from 'sel'
#-----------------------------------------------------------------------------
proc my_vw2_display {sel} {

set tmp [pr_selection [pr_sel_new] name]
my_selection $sel $tmp

pr_lay -set node_size 1.0
pr_lay -set keep_dims 0
pr_lay -set use_crt_pos 0
pr_lay -set use_crt_dim 0
pr_lay_neato -set edgelen 0.01
pr_lay_neato -set weight 10.0

pr_lay_nested $tmp pos2 traverse "type" "level"
pr_select_edges_by_type $tmp "nested_sel" "level" 0
pr_selection [pr_get_selection name $tmp] delete

pr_view vw2 set selection "nested_sel"
}

# my_selection: custom selection proc for viewer vw2
#-------------------------------------------------------
proc my_selection {inp out} {
   set so [pr_sel_new $out]
   set si [pr_get_selection name $inp]
   set all [pr_get_selection name "All"]
   set i [pr_selection $si iter_nodes]
   set n [pr_iterator $i next_node]
   while {$n!=0} {
      set se [pr_node $n edges $all]
      set j [pr_selection $se iter_edges]
      set e [pr_iterator $j next_edge]
      while {$e!=0} {
        if {[pr_edge $e type]=="composite"} {
	     set n1 [pr_edge $e node from]; set n2 [pr_edge $e node to]
	     if {[expr [pr_selection $si contains node $n1] && [pr_selection $si contains node $n2]]} {
              pr_selection $so add_edge $e
	     }
        } 
	  set e [pr_iterator $j next_edge]
      }
      pr_selection $se delete
      pr_selection $so add_node $n
      set n [pr_iterator $i next_node]
   }
   set j [pr_selection $si iter_edges]
   set e [pr_iterator $j next_edge]
   while {$e!=0} {
      pr_selection $so add_edge $e
      set e [pr_iterator $j next_edge]
   } 
}

proc my_vw3_cb {opt val} {
     if {$opt=="edge"} { return }
	 if {$opt=="selection"} { 
	    if {[pr_selection [pr_get_selection name $val] nnodes]==0} { return }
     }
     set subtree [pr_selection [pr_sel_new] name]
     set root [pr_selection [pr_sel_new] name]

     if {$opt=="node"} {
        set n [pr_get_node All id $val]
		set lmin [pr_node $n attr "global_level"]
        pr_selection [pr_get_selection name $root] add_node $n
     } 
     if {$opt=="selection"} {
        pr_selection_op reunion $val "None" $root
	    set i [pr_selection [pr_get_selection name $root] iter_nodes]
		set n [pr_iterator $i next_node]
		set lmin [pr_node $n attr "global_level"]
        while {$n!=0} {
		   set l [pr_node $n attr "global_level"]
		   if {$lmin<$l} { set lmin $l }
		   set n [pr_iterator $i next_node]
		}
     }
     
     pr_traverse_tree [pr_get_selection name "vis_tree"] [pr_get_selection name $root] type "level" $subtree

     #Set a flag to indicate if we need to relayout anything or not
     set layout 0

     if {[pr_selection [pr_get_selection name $subtree] nnodes]==[pr_selection [pr_get_selection name $root] nnodes]} {
	    #Leaf selection - open tree underneath 4 levels deep; must do a relayout
	    #
	    set lmax [expr $lmin+4]
        pr_traverse_tree [pr_get_selection name "full_tree"] [pr_get_selection name $root] type "level" $subtree
        
		set i [pr_selection [pr_get_selection name $subtree] iter_nodes]
		set n [pr_iterator $i next_node]
		while {$n!=0} {
		   set l [pr_node $n attr "global_level"]
		   if {$l<$lmax} { pr_node $n set "open" 1 int }
		   set n [pr_iterator $i next_node]
		} 
		set layout 1
     } else {
	    #Non-leaf selection - close tree underneath except highlight selection; no relayout needed
		#
		pr_set [pr_get_selection name $subtree] "open" 0 int
		pr_set [pr_get_selection name $root] "open" 1 int
	 }
     
	 #Done with the local selections
     pr_selection [pr_get_selection name $subtree] delete
	 pr_selection [pr_get_selection name $root] delete

     pr_select_nodes_by_value "full_tree" "vis_tree" "open" 1
     if {$layout==1} { pr_lay_dot "vis_tree" pos3 }
}   



# Marks all composite-edges in main_sel which have an end-node in hl_sel with
# attribute "visible" 1 and the others with "visible" 0. 
# This procedure is used by the user-cb of vw2.
#-----------------------------------------------------------------------------------
proc show_composite_edges {main_sel hl_sel} {
   set ms  [pr_get_selection name $main_sel]
   set hs  [pr_get_selection name $hl_sel]
   set all [pr_get_selection name "All"]
   set i [pr_selection $ms iter_edges]
   set e [pr_iterator $i next_edge]
   while {$e!=0} {
     if {[pr_edge $e type]=="composite"} {
	     set n1 [pr_edge $e node from]; set n2 [pr_edge $e node to]
	     if {[expr [pr_selection $hs contains node $n1] || [pr_selection $hs contains node $n2]]} {
              pr_edge $e set "visible" 1 int
	     } else {
              pr_edge $e set "visible" 0 int
           }
     }
     set e [pr_iterator $i next_edge]
   }
}



# Sweep-proc for viewers. Displays node name and type.
#---------------------------------------------------------------
proc my_sweep_cb {opt val} {

  set ret ""
  if {$opt=="node"} { 
     pr_gui:attrset_refresh_id .nodes $val
     set n  [pr_get_node All id $val]
     set nm [pr_node $n attr "name"]
     set tp [pr_node $n type]
     return [join [list $nm $tp] "\n"]
  }  
  if {$opt=="edge"} {
     pr_gui:attrset_refresh_id .nodes $val
     set e  [pr_get_edge All id $val]
     return [pr_edge $e type]
  }
  return ""
}



