pr_domain_load_rsf DATA3
pr_load DATA3/cream_core.rsf


#  Select separately the "subscribeEvent" and "isiMessage" arcs
#-------------------------------------------------------------------
pr_select_edges_by_type All subscribeEvent "subscribeEvent" 1
pr_select_edges_by_type All isiMessage "isiMessage" 1

# Make several viewers for the data
#-------------------------------------------------------------------
pr_lay_neato    All pos
pr_view_new vw  All pos hl_sel
pr_view_new vw2 subscribeEvent pos hl_sel
pr_view_new vw3 isiMessage pos hl_sel

# Simple edge-glyph procedure to display edge types with different colors
#------------------------------------------------------------------------
proc my_edge_glyph {e x y z} {
    set t [pr_edge $e type]
    if {$t=="invocation"} { 
       set r 1; set g 0; set b 0
    } elseif {$t=="isiMessage"} {
        set r 0; set g 1; set b 0
    } elseif {$t=="subscribeEvent"} {
        set r 1; set g 1; set b 0
    }

    return [pr_make_line edge $e x $x y $y z $z color $r $g $b $r $g $b]
}

proc my_node_glyph {n} {
    set t [pr_node $n type]
    if {$t=="Server"} { 
       return [pr_make_file file IV/file.iv color 1 0 1]
    } elseif {$t=="Application"} {
	 return [pr_make_file file IV/triangle.iv color 0.2 0.2 1]
    } else {
	return 0
   }
}

# Make two glyph-factories and use them for viewer 'vw'.
# Use the above defined Tcl scripts for these factories.
#---------------------------------------------------------------
pr_glyphs new IVTclNodeGlyphFactory my_node_factory
set gf [pr_glyphs get node_glyph name my_node_factory] 
pr_glyph_factory $gf set cb my_node_glyph

pr_glyphs new IVTclEdgeGlyphFactory my_edge_factory
set gf [pr_glyphs get edge_glyph name my_edge_factory] 
pr_glyph_factory $gf set cb my_edge_glyph

pr_view vw set node_glyph my_node_factory
pr_view vw set edge_glyph my_edge_factory
pr_view vw set node_scale 0.02
pr_view vw set sweep_cb my_sweep_cb 

pr_view vw2 set node_glyph my_node_factory
pr_view vw2 set edge_glyph my_edge_factory
pr_view vw2 set node_scale 0.02
pr_view vw2 set sweep_cb my_sweep_cb 


pr_view vw3 set node_glyph my_node_factory
pr_view vw3 set edge_glyph my_edge_factory
pr_view vw3 set node_scale 0.02
pr_view vw3 set sweep_cb my_sweep_cb 


# Sweep-proc for viewers. Displays node name and type.
#---------------------------------------------------------------
proc my_sweep_cb {opt val} {
  set ret ""
  if {$opt=="node"} { 
     pr_gui:attrset_refresh_id .nodes $val 
     set n  [pr_get_node All id $val]
     set nm [pr_node $n attr "name"]
     set tp [pr_node $n type]
     return [join [list $nm $tp] "\n"]
  }  
  if {$opt=="edge"} {
     pr_gui:attrset_refresh_id .nodes $val 
     set e  [pr_get_edge All id $val]
     return [pr_edge $e type]
  }
  return ""
}
