pr_compo_lib add_proc my_node_glyph "Whatever there is"
pr_compo_lib add_proc my_node_glyph2 "Whatever again"
pr_compo_lib add_proc my_edge_glyph "Edge proc..."



# Glyph-proc for vw2
#
proc my_node_glyph {node} {
    set t [pr_node $node type]
    if {$t=="Interface"} {
       set r 1; set g 1; set b 0 
    } elseif {$t=="Application"} {
       set r 0; set g 1; set b 0
    } elseif {$t=="Server"} {
       set r 0; set g 0; set b 1 
    } elseif {$t=="Subsystem"} {
       set r 1; set g 0; set b 1
    } else {
       set r 1; set g 1; set b 1
    }    
    return [pr_make_cube color $r $g $b style lines]
}

# Glyph-proc for vw and vw3
#
proc my_node_glyph2 {node} {
    set t [pr_node $node type]
    if {$t=="Interface"} {
       set r 1; set g 1; set b 0 
    } elseif {$t=="Application"} {
       set r 0; set g 1; set b 0
    } elseif {$t=="Server"} {
       set r 0; set g 0; set b 1 
    } elseif {$t=="Subsystem"} {
       set r 1; set g 0; set b 1
    } else {
       set r 1; set g 1; set b 1
    }    
    return [pr_make_cube color $r $g $b] 
}

proc my_edge_glyph {e x y z} {
    set t [pr_edge $e type]
    if {$t=="level"} { 
       set r 1; set g 1; set b 0
    } elseif {$t=="composite"} {
	 set n1 [pr_edge $e node from]; set n2 [pr_edge $e node to]
	 if {[pr_node $n1 attr "level_val"]==[pr_node $n2 attr "level_val"]} {
          set r 0; set g 1; set b 0
       } else {
          if {[pr_edge $e attr "visible"]=="1"} {
             set r 1; set g 1; set b 1
          } else {
	      return  [pr_make_line edge $e x $x y $y z $z style invisible]
	    }
       }
    } else {
       set r 1; set g 1; set b 1
    } 
    return [pr_make_line edge $e x $x y $y z $z color $r $g $b $r $g $b] 
}
