pr_domain_load_rsf DATA

# Load large graph (~1500 nodes/5000 edges)
#
#
pr_load DATA/venice.rsf
pr_sel_new hl_sel
pr_sel_new tree



pr_filter_edges_by_type All sel {contain_file contain_dir contain inherit}
pr_filter_edges_by_type All sel2 {access}

# Use GEM as a layout-engine, it's the best/fastest for large graphs...
#
#
pr_lay_gem sel pos
pr_lay_grid sel2 pos2

# Use simple line glyphs with the fast 'basic' edge-mapper.
# This makes the rendering much faster.
#

proc my_glyph {e x y z} {
    set t [pr_edge $e type]
    if {$t=="composite"} {
       return [pr_make_line edge $e x $x y $y z $z color 1 0 0 1 0 0]
    }
    if {$t=="level"} {
       return [pr_make_line edge $e x $x y $y z $z color 0 0 1 0 0 1]
    }
    if {$t=="invocation"} {
       return [pr_make_line edge $e x $x y $y z $z color 1 1 0 1 1 0]
    }
    return [pr_make_line edge $e x $x y $y z $z color 1 1 1 1 1 1]
}

pr_glyphs new IVTclEdgeGlyphFactory my_mapper
pr_glyph_factory [pr_glyphs get edge_glyph name my_mapper] set cb my_glyph

#Callback for mouse-clicks in vw1: displays method & attribute trees of the
#					     highlight-selection hl_sel in vw3
#
proc my_vw1_cb {opt val} {
  #Treat only nodeclick and selection-events
  #
  if {$opt=="edge"} { pr_gui:attrset_refresh_id .nodes $val; return }
  if {$opt=="node"} { pr_gui:attrset_refresh_id .nodes $val }
  
  # 'root' is the root of the selection to build
  set root hl_sel
  # Build two types of trees for the "has_method" and "has_attribute" edges
  #
  set tmp1 [pr_sel_new]; set tmp2 [pr_sel_new]
  pr_traverse_dag [pr_get_selection name $root] type "has_method"    [pr_selection $tmp1 name]
  pr_traverse_dag [pr_get_selection name $root] type "has_attribute" [pr_selection $tmp2 name]
  # Put the two types of trees together
  #
  pr_selection_op reunion [pr_selection $tmp1 name] [pr_selection $tmp2 name] "tree"
  # Done with selections tmp1 and tmp2
  #
  pr_selection $tmp1 delete; pr_selection $tmp2 delete
  # Refresh viewer vw3 to show selection "tree"
  #
  my_vw3_refresh "tree"
}  

pr_view_new vw sel pos hl_sel
pr_view vw set edge_glyph my_mapper
pr_view vw set user_cb my_vw1_cb 

pr_view_new vw2 sel2 pos2 hl_sel
pr_view vw2 set edge_glyph my_mapper
pr_view vw2 set user_cb my_show_node

pr_view_new vw3 tree pos3 hl_sel
pr_view vw3 set edge_glyph my_mapper
pr_view vw3 set user_cb my_show_node

#Procedure for refreshing contents of vw3
#
#
proc my_vw3_refresh {sel} {
  pr_lay_neato $sel pos3
  pr_view vw3 set selection $sel
}

#Procedure for node-clicks in viewers
#
#
proc my_show_node {opt val} {
  if {$opt=="node"} { pr_gui:attrset_refresh_id .nodes $val }
  if {$opt=="edge"} { pr_gui:attrset_refresh_id .nodes $val }
}


  