#include "Element.h"
#include "Selection.h"
#include <iostream.h>


int    Element::crt_id    = 0;		//Simple mechanism to make unique ids. Does a partial id-recycling upon
int    Element::num_insts = 0;          //release. See ~Element() too.       


int Element::makeId(int given_id)	//Makes unique ids. If given_id==-1, use crt_id which is guaranteed not
{					//to be in use. If given_id!=-1, use the given_id (caller know what he's doing)
   if (given_id==-1) return crt_id++;   //but set crt_id to max(crt_id,given_id)+1 to ensure uniqueness.
   if (given_id>=crt_id) crt_id=given_id+1;
   return given_id;
}


void Element::addToSelection(Selection* s)
{
   sels.Append(s); refcount++;
}

void Element::delFromSelection(Selection* s)	//assumes this is indeed in Selection 's'
{
   if (sels.Remove(s)==-1) cerr<<"Internal Error: Element::delFromSelection(): removing element from selection "
	                       <<s->getName()<<" not owning it"<<endl;
   
   refcount--;

   if (refcount<0) cerr<<"Internal Error: Element::delFromSelection(): refcount: "<<refcount<<" on "<<this<<endl;

   if (refcount==0) delete this;
}


Element::~Element()                     //Dtor. Does a kind of id-recycling. When all Elements are destroyed,
{                                       //it means there are no ids in use, so we can reset crt_id.
  num_insts--; if (!num_insts) crt_id = 0;
}