#include "GenAttrSetType.h"
#include "AttrType.h"
#include <iostream.h>


const AttrType*	GenericAttrSetType::getAttrType(const char* n) const
{
   for(int i=attrs.Count()-1;i>=0;i--)
      if (attrs[i]->getName()==n) return attrs[i];
   return 0;
}	


GenericAttrSetType::~GenericAttrSetType()		//Delete all AttrTypes in this.
{							//We own them, so we can do this.
   for(int i=0;i<attrs.Count();i++)
      delete attrs[i];
}

					
void GenericAttrSetType::add(AttrType* t)
{
   const STRING& n = t->getName();

   for(int i=attrs.Count()-1;i>=0;i--)
      if (attrs[i]->getName()==n)
      {
	  delete attrs[i];
	  attrs[i] = t;
 	  return;
      }

   attrs.Add(t);
}

int GenericAttrSetType::numAttrTypes() const
{  return attrs.Count();  }

const AttrType* GenericAttrSetType::getAttrType(int i) const
{  return attrs[i];  }

 