#include "GenDomainModel.h"
#include "GenAttrSetType.h"
#include "utils.h"



GenericDomainModel::GenericDomainModel(const char* n): DomainModel(n)
{  
}


GenericDomainModel::~GenericDomainModel()	
{
}


void GenericDomainModel::addNodeType(GenericAttrSetType* a)	//Adds an attr-set-type to this.
{								//Simply delegate to parent, we don't do
    DomainModel::addNodeType(a);				//anything special with this operation
}

void GenericDomainModel::addArcType(GenericAttrSetType* a)	//Adds an attr-set-type to this.
{								//Simply delegate to parent, we don't do
    DomainModel::addArcType(a);		 			//anything special with this operation
}


void GenericDomainModel::save(FILE* fp)                         //Impl inh. Save cmd to restore from own-format
{                                                               //We save this ONLY if we have a valid domain_file.
    if (domain_file!="")                                        //If not, it means we use a DomainModel NOT loaded from a file, 
                                                                //e.g. the default one, which we shouldn't save.
       fprintf(fp,"pr_domain_load_own %s\n",(const char*)addQuotes(domain_file));
}