#include "Observer.h"
#include "GraphManager.h"
#include "SelList.h"
#include "Selection.h"
#include "ObsList.h"


Observer::Observer(const char* name,const char* selname)	//Construct a new Observer and also add it
	 :GVObject(name),					//to the observers-list
	  sel(selname),
	  persist(FALSE),
	  always_update(FALSE)
{   
   GraphManager::getInstance()->getObsList()->addObserver(this);
}


Observer::~Observer()
{   }

BOOL Observer::mustBeUpdated() const
{
      return alwaysUpdate() || 
	     GraphManager::getInstance()->getSelList()->getSelection(getSelection())->isModified();
}