#include "Registry.h"

 
Registry::~Registry()							//Dtor. Destroy dynamically allocated info
{
    for(std::map<STRING,DARRAY<Element*> >::iterator i=data.begin();i!=data.end();i++)
    {
        DARRAY<Element*>& a = (*i).second;
	for(int j=0;j<a.Count();j++)
           delete a[j];
    }
}

void Registry::add(const STRING& key,DARRAY<STRING>& val)		//Append set-of-strings for given key
{
    std::map<STRING,DARRAY<Element*> >::iterator i = data.find(key);	//find entry-set for given key
    Element* e = new Element(val);					//make local copy of new entry
    if (i==data.end())							//'key' not used so far, make new entry-set
    {
       DARRAY<Element*> a; a.Add(e);					//...and add local copy to it
       std::map<STRING,DARRAY<Element*> >::value_type v(key,a);	
       data.insert(v);
    }
    else								//'key' exists, just add to its entry-set
      (*i).second.Add(e);					

    //WARNING!!! We should actually check whether this set doesn't exist for
    //		 the given key. Otherwise we might have duplicate (identical)
    //		 sets-of-strings for the same key...
									
}


Registry::Iterator::Iterator(Registry& r,const STRING& k)		//New iterator for elems under key 'k'
{
   std::map<STRING,DARRAY<Element*> >::iterator it = r.data.find(k);
   i = (it==r.data.end())? 0 : &(*it).second;
}

int Registry::Iterator::num()						//Get # total elems in this iterator
{  return (i)? i->Count() : 0; }

Registry::Element& Registry::Iterator::get(int idx)			//Get ith elem in this iterator
{  return *((*i)[idx]);  }						//(i MUST be < num())

 
