#  Procedures for editing Tcl scripts (procs/code fragments) from
#  within the system.
#
#--------------------------------------------------------------------


# pr_dialog:text_input: Simple dialog box for text input with customized buttons and labels.
#
#
proc pr_dialog:text_input {w label validatecmd btns} {
    
    toplevel $w
    frame $w.top -relief raised -bd 1

    tixLabelEntry $w.top.a -label $label -options { entry.width 20 label.anchor w }

    pack $w.top.a -side left -anchor w -expand yes -fill x 
    
    #Build the buttons of the window
    #
    tixButtonBox $w.box -orientation horizontal -padx 1
    set idx 0
    foreach btn $btns {
        set name [lindex $btn 0]
        set cmd  [lindex $btn 1]
        while {1} {
           set pos  [string first "%W" $cmd]
	   if {$pos!=-1}  {set cmd [string replace $cmd $pos [expr $pos+1] $w]} else break
        }	
        $w.box add $idx -text $name -command $cmd -width 7
        incr idx
    }

    pack $w.box -side bottom -fill x
    pack $w.top -side top -fill both -expand yes
}

proc pr_dialog:text_get {w} {
   return [[$w.top.a subwidget entry] get]
}



