#-------------------------------------------------------------------
#  Code for the file loading dialog and procedures
#-------------------------------------------------------------------

# pr_load:  Toplevel entry point to loading the various formats supported.
#	      Dispatches to specific loader using file extension to determine type.	
#
proc pr_load {fn} {
   if [string equal -nocase [file extension $fn] ".dat"] {pr_read_own_format $fn}
   if [string equal -nocase [file extension $fn] ".g"]   {pr_read_graph_ed $fn}
   if [string equal -nocase [file extension $fn] ".rsf"] {pr_read_rsf $fn}
   if [string equal -nocase [file extension $fn] ".tcl"] {pr_read_tcl $fn}
}


proc pr_load_dlg {} {
   set types  { 
   		    {{All files}	         {*}}
	  	    {{GraphED files}             {.g .G}}
                    {{GraphViz files}   	 {.dot}}
                    {{Own Format files} 	 {.dat}}
                    {{Rigi unstructured files}   {.rsf}}
		    {{Tcl files}                 {.tcl}}
              }

   set sel [tk_getOpenFile -filetypes $types];
   if [llength $sel] {
      pr_load $sel
   }
}


proc pr_load_domain {} {
   set sel [tk_chooseDirectory -mustexist 1]
   pr_domain_load_rsf $sel
}  

