#  Procedures for managing the Settings GUI component
# 
#
#--------------------------------------------------------------------


#  pr_gui:view {wid}: main entry point
#-------------------------------------------------------------------------------
proc pr_gui:settings {wid} {
   if {[info commands .$wid]!={}} { raise .$wid; return }
   toplevel .$wid

   frame .$wid.top; set top .$wid.top; pack $top -fill x
   set opts { label.width 20 label.anchor w }
   label      $top.lbl    -text  "System options" -justify center; pack $top.lbl -fill x 
   tixSelect  $top.ldclr  -label "Clear data on load" -options $opts -allowzero true; \
		  pack $top.ldclr -fill x
   $top.ldclr add btn
   [$top.ldclr subwidget btn] configure -image [image create photo -file [pr_qualify RSCS/tick.gif]]
   
   # Initialize the state of the dialog:
   
   tixButtonBox .$wid.box -orientation horizontal
   .$wid.box add ss  -text "Apply"  -command "pr_gui:settings:ok .$wid"
   .$wid.box add cc  -text "Cancel" -command "destroy .$wid"
   pack .$wid.box -side bottom -fill x
   bind .$wid <Destroy> { destroy %W }
   pr_gui:settings:refresh .$wid
}


#-------------------------------------------------------------------------------

proc pr_gui:settings:ok {wid} {
   set top $wid.top
   pr_config set clear_at_load [expr [string compare [$top.ldclr cget -value] btn] + 1]
}

proc pr_gui:settings:refresh {wid} {
   set top $wid.top
   set x [pr_config get clear_at_load]
   if {$x==1} { $top.ldclr config -value {btn} } else { $top.ldclr config -value {} }
}

