#ifndef PR_ATTR_SET_TYPE_H
#define PR_ATTR_SET_TYPE_H

//  AttrSetType:	Models a group of attr-types. Basically this models the type of an AttrSet object, thus of 
//			a Node or Edge. An AttrSetType is thus a kind of 'type' like a struct or a class.
//			AttrSetType declares only the interface to a collection of AttrTypes, not its
//			implementation. The implementation is left to the concrete sbuclasses of this.
//
//
//

#include "Genrl/string.h"


class   AttrType;


class	AttrSetType
	{
	public:
	
	
	virtual	       	       ~AttrSetType();				//Dtor
	const STRING&		getName() const;			//Get this's name
	virtual const AttrType*	getAttrType(const char*) const =0;	//Get attr-type of this by name (0 if not found)
        virtual int		numAttrTypes() const =0;		//Iterator
        virtual const AttrType* getAttrType(int) const =0;		//Iterator

	protected:
				AttrSetType(const char*);		//Ctor (set-name)
	STRING			name;
	};




inline const STRING& AttrSetType::getName() const
{  return name;  }




#endif
