#ifndef PR_ATTR_TYPE_H
#define PR_ATTR_TYPE_H

//  AttrType:	Models the 'declaration' for an Attr object. Basically, this contains a name	
//		and a type. An AttrType is thus like a member declaration of a struct or class.
//		Attr objects that are conceptually instances of this AttrType 
//		will thus use its name and type. However, so far we have no explicit relationship
//		between the Attr-objects and the AttrTypes.
//
//

#include "Attr.h"
#include "Genrl/string.h"


class AttrType	{
		public:
		
			
				AttrType(const char*,Attr::TYPE);
		const STRING&	getName() const;
		Attr::TYPE	getType() const;
				
		private:

		STRING		name;
		Attr::TYPE	type;

		};


inline AttrType::AttrType(const char* n,Attr::TYPE t): name(n),type(t)
{  }

inline const STRING& AttrType::getName() const
{  return name;  }

inline Attr::TYPE AttrType::getType() const
{  return type;  }

  

#endif
