#ifndef PR_FLOAT_VEC_IMP_H
#define PR_FLOAT_VEC_IMP_H

//	FloatVecImp:	Implements a simple vector of floats. This object is used internally by Attr to implement
//			float-vectors. FloatVecImp is faster and more compact than generic (e.g. template) containers.
//
//

#include <string.h>

class	FloatVecImp  
	{
	public:
			FloatVecImp(const float*,int);
			FloatVecImp(const FloatVecImp&);
		       ~FloatVecImp();
	FloatVecImp&	operator=(const FloatVecImp&);
	int		operator==(const FloatVecImp&) const;
	int		compare(const float*,int) const;
			
	float*		data;			//the float-vector
	int		size;			//the #floats in 'data'
	};


inline FloatVecImp::FloatVecImp(const float* f,int n): size(n),data(new float[n])
{   memcpy(data,f,n*sizeof(float));  }

inline FloatVecImp::~FloatVecImp()
{   delete[] data;  }

inline FloatVecImp::FloatVecImp(const FloatVecImp& i): size(i.size),data(new float[i.size])
{   memcpy(data,i.data,size*sizeof(float));  }

inline FloatVecImp& FloatVecImp::operator=(const FloatVecImp& i)
{  
    if (this==&i) return *this; 
    delete[] data;
    size = i.size;
    data = new float[size];
    memcpy(data,i.data,size*sizeof(float)); 
    return *this;
}

inline int FloatVecImp::operator==(const FloatVecImp& i) const
{
    if (size!=i.size) return 0;
    return (!memcmp(data,i.data,size*sizeof(float)));
}

inline int FloatVecImp::compare(const float* f,int n) const
{
    if (!f || size!=n) return 0;
    return (!memcmp(data,f,size*sizeof(float)));
}




#endif
