#ifndef PR_GUI_MANAGER_H
#define PR_GUI_MANAGER_H

//  GUIManager:		This class gathers all stuff that relates to the graphical and command-line
//			user interfaces. Basically this is the Tcl and Tk stuff and the loose bits
//			of Xt that we have to be aware of.
//
//



#include "Genrl/types.h"
#include "Genrl/string.h"


class	GUIManager
	{
	public:
	
	
	static void			init();				//Initialize GUI subsystem	 
	static void			mainLoop();			//Enters combined Tk/Xt event loop
	static void			shutdown();			//Main exit point
	static void			error(const char*,		//Client code asks GUI to post Tk error msg
					      const char* =0);		
	static void			error(const char*,int);		//Same as above but displaying different info
        static BOOL			exec(const char*);		//Client code asks Tcl code to be exec'd
        								//return TRUE if exec ok else FALSE
        static BOOL			execFile(const char*);		//Client code asks to exec Tcl file
        								//return TRUE if exec ok else FALSE
        static long			getLongResult();		//Get result of last Tcl op as long.
        static STRING                   getStringResult();              //Get result of last Tcl op as string.
        static void                     saveTclProc(FILE*,const char*); //Save Tcl-proc-def with given name in given file
        static int			spawn(const char*);
        								
	protected:
	
					GUIManager();
		       		       ~GUIManager();
	static void			resetError();			//Resets error msg buffer
	static GUIManager*		instance;			
	static char 			err_buf[1024];
	static BOOL			exit_flag;
	};
	


inline void GUIManager::resetError()
{  err_buf[0]='\0';  }	

#endif