#ifndef PR_GUI_OBSERVER_H
#define PR_GUI_OBSERVER_H

//  GUIObserver:	A concrete Observer that is responsible for refreshing a
//			Tcl GUI component. This Observer receives a piece of Tcl code
//			that it has to execute to refresh its GUI in its update().
//			The idea behind GUIObservers is that this is a simple way to
//			implement the refreshing of the Tcl GUIs when the core data
//			structures change.


#include "Observer.h"
#include "Selection.h"
#include "Genrl/string.h"


class	GUIObserver : public Observer
	{
	public:

			GUIObserver(const char* name, const char* tcl_code);	
	void		update();		//impl inh: refresh the Tcl GUI
		
	private:
	
	STRING		tcl_code;	
	};


inline GUIObserver::GUIObserver(const char* n1,const char* n2)
                     : Observer(n1,Selection::NONE),	//we pass name to Observer and let it set
                       tcl_code(n2)			//the observed selection to NONE
{   
	setPersistent(TRUE);				//this is a persistent observer
	updateAlways(TRUE);				//this is always to be updated, since it monitors
							//no specific selection
}


			

#endif
