#ifndef PR_GVOBJECT_H
#define PR_GVOBJECT_H

#include "Genrl/string.h"
#include "Genrl/types.h"


//	GVObject:	A class for the basic named object in the system.
//			A GVObject is an object that can have a name and be retrieved as such.
//
//
//

class   GVObject
  	{
  	public:
  	
  		virtual	       ~GVObject();
		const STRING&	getName() const;			//get name
		BOOL		operator==(const char*) const;		//verify name
  	
	protected:
	
				GVObject(const char*);
		void		setName(const char*);			//rename - protected since these objs might be name-registered
  	
  	private:
  	
  		STRING		name;  	
  	};	



inline GVObject::GVObject(const char* n): name(n)
{  }

inline const STRING& GVObject::getName() const
{  return name;  }

inline void GVObject::setName(const char* n)
{  name = n;  }

inline BOOL GVObject::operator==(const char* n) const
{  return name==n;  }

#endif
