#ifndef PR_GEN_ATTR_SET_TYPE_H
#define PR_GEN_ATTR_SET_TYPE_H


//  GenericAttrSetType:	Specialization of AttrSetType. This models a collection of 
//			AttrTypes which are stored directly into this class, so it is the most
//			generic (unconstrained) way in which a set of AttrTypes can be modelled. 
//

#include "AttrSetType.h"
#include "Genrl/darray.h"


class   AttrType;


class	GenericAttrSetType : public AttrSetType
	{
	public:
		
				GenericAttrSetType(const char*);	//Ctor (set-name)
		       	       ~GenericAttrSetType();			//Dtor
	void			add(AttrType*);				//Add new AttrType to this.
									//If attr-type with same name already present,
									//existing one is first deleted.
	const AttrType*		getAttrType(const char*) const;		//impl inh
	int			numAttrTypes() const;			//impl inh
	const AttrType*		getAttrType(int) const;			//impl inh


	protected:

	DARRAY<AttrType*>	attrs;
	};


inline GenericAttrSetType::GenericAttrSetType(const char* n): AttrSetType(n)
{  }


#endif
