#ifndef CARRAY_H
#define CARRAY_H



// CLASS CARRAY:   A very simple 'circular array' class allowing modulo
//                 like of indexing of an integer array.


#include "array.h"


template <class T> class CARRAY : public ARRAY<T>
		{
		   public:

		   CARRAY(int maxsize); 
		   T&   operator[] (int i);
		   T&   operator() (int i);
		};

template <class T>  CARRAY<T>::CARRAY(int maxsize) :
   ARRAY<T>(maxsize) { count = maxsize; }

template <class T>  T& CARRAY<T>::operator[](int i)
{ return array[((i%count)+count)%count]; }

template <class T>  T& CARRAY<T>::operator()(int i)
{ return array[i]; }

		
#endif

