#ifndef PR_GRAPH_ED_H
#define PR_GRAPH_ED_H

//  This is an implementation header. It contains the 'public'
//  functions made available by GraphEd.cc for the rest of the toolkit.
//  -------------------------------------------------------------------



int read_graphed(FILE*,Selection*,int,int,const char*,const char*,const char*);
//Reads GraphEd file arg1 into Selection arg2. The read ids are offset with arg3 - useful 
//if one wants to read several graphs incrementally. arg4 tells if we should read 
//position-data. If yes, it is read as attrs arg5(x),arg6(y),arg7(z).


int write_graphed(FILE*,Selection*,int wr_pos,int wr_ids,const char*,const char*);
//Writes given Selection arg2 as GraphEd file arg1. If arg3==1, 2D-position-data, given
//by attrs arg4(x) and arg5(y), is written to the file. The node-ids are written to ID-attrs
//in the file.


int read_graphed_pos(FILE*,Selection*,const char*,const char*,const char*);
//Reads position-data from GraphEd file arg1. The routine assumes the GraphEd file contains
//node ID-data. The routine locates the nodes with the same ids in the Graph (arg2) and
//sets their positions from the file data. The positions are normalized in [0..1,0..1].
//This routine is used internally by the GEM-based layout component.

#endif
















