#ifndef PR_IV_GLYPHS_H
#define PR_IV_GLYPHS_H

//	IVGlyphs:	This class offers a simple argv-style interface to IV glyph construction. IVGlyph's
//			methods are mainly called from Tcl methods that construct glyphs, such as the
//			glyph-factory IVTclGlyphFactory's Tcl callback.
//
//			The methods return the constructed SoNode. The caller owns it.
//

#include "Genrl/types.h"
#include "Genrl/string.h"


class	SoGroup;
class	SoNode;
class   SoMaterial;
class   SoDrawStyle;
class   Node;
class   Edge;


class	IVGlyphs	 				//
	{						//
	public:						//
	

	static void		initialize();
			
	static SoNode*		cube(char* []);
	static SoNode*		sphere(char* []);
	static SoNode*		line(char* []);
	static SoNode*		file(char* []);
	static SoNode*		bar(char* []);
	static SoNode*		defaultNode(Node*);
	static SoNode*		defaultEdge(Edge*,const char*,const char*,const char*);
	//.... new, more complex ones....
		

	//----------  Global parameters  ----------------------------------	
	
	static void		setScale(float);	//Global scale param for various glyph-parts.	
	static float		getScale();		//
	
	private:
	
	static SoGroup*		base();
	static void		processNodeDefaults(SoGroup*,char** &);
	static void		processEdgeDefaults(SoGroup*,char** &);
	static void		processStart();
	
	
	static Edge*		edge;
	static float		start_r,start_g,start_b,
				end_r,end_g,end_b;
	static STRING		pos_x,pos_y,pos_z;			
	static SoNode*		def_icon;
	static SoNode*		def_node;
	static SoNode*		def_cube;
	static SoMaterial*	material;
	static SoDrawStyle*	draw_style;
	static float		scale;
	};
	


inline float IVGlyphs::getScale()
{  return scale;  }

inline void IVGlyphs::setScale(float s)
{  scale = s;  }



#endif
