#ifndef PR_REGISTRY_H
#define PR_REGISTRY_H

// Registry:	Simple (key,list-of-values) type of database for storing system information.
//		The registry can be used by anyone who needs to store sets of strings under
//		a given key. For the same key, several such sets may exist. The registry allows
//		adding a new set and iterating over the existing sets for a given key
//


#include "Genrl/darray.h"
#include "Genrl/string.h"
#include "Genrl/types.h"
#include <map>

class	Registry 
	{	
	public:

	typedef DARRAY<STRING>  Element;
	
			       ~Registry();	
	void		        add(const STRING&,Element&);

	class Iterator		{
				public:
				  
				         Iterator(Registry&,const STRING&);
				int      num();
				Element& get(int);

				private:
		
				DARRAY<Element*>* i;
				};

	private:

		friend class	Iterator;
		std::map<STRING,DARRAY<Element*> > data;
	};







#endif