#ifndef PR_SELECT_OP_H
#define PR_SELECT_OP_H

//	SELECT		These operations construct a new Selection from some input data (usually some other Selections)
//	OPERATIONS:     Available operations:
//
//			SelectGenericOp::select(n):	  make new generic-selection with name n
//		        SelectSetOp::reunion(s1,s2,s3):   s3 = union of s1 and s2
//			           ::intersect(s1,s2,s3): s3 = intersection of s1 and s2
//				   ::edges(s1,s2,s3):	  s3 = s1 and all edges in s2 connecting nodes in s1
//				   ::nodes(s1,s2):	  s2 = only nodes from s1
//		
//			

class 	Selection;
class	Filter;
class	DirectionFilter;
class   Attr;

class   SelectSetOp : public WriteOperation
			{
			public:
				static void reunion(Selection* in1,Selection* in2,Selection*& out);
				static void intersect(Selection* in1,Selection* in2,Selection*& out);
				static void difference(Selection* in1,Selection* in2,Selection*& out);
				static void xor(Selection* in1,Selection* in2,Selection*& out);
				static void edges(Selection* in1,Selection* in2,Selection*& out);
				static void nodes(Selection* in,Selection*& out);
				static void dag(Selection* in,Selection* all,Filter*,Selection*& out);
				static void tree(Selection* in,Selection* all,DirectionFilter*,const char* level,
						 Selection*& out);
				static void roots(Selection* in,Filter*,Selection*& out);
				static void attr(Selection* in,const char* name,const Attr& val,Selection*& out);
			};							

class	SelectGenericOp : public WriteOperation
			{
			public:				
				static void select(Selection*& out);
			};



#endif

