#ifndef PR_UI_IMP_H
#define PR_UI_IMP_H

//  UI_imp.h:	Counterpart to UI.h containing the implementation-related headers
//              and #define's    
//
//
//

#include "UI.h"

#ifdef WIN32
//MS-Windows:
#include <Inventor/Win/viewers/SoWinPlaneViewer.h>
#include <Inventor/Win/viewers/SoWinExaminerViewer.h>
#include <Inventor/Win/SoWin.h>

class   SoUIExaminerViewer : public SoWinExaminerViewer, public UIViewerBase	
	{
	public:
				SoUIExaminerViewer();
			       ~SoUIExaminerViewer();
	static void		initialize();				//Initializes class with OS-specific info			       
	void			pan(PAN_DIRECTION);			//Pan view with one step in given direction
	void			addButton(const char*,const char*,
					  const char*,BOOL);		//Impl inh
	void                    viewAll();                              //Enh inh

	protected:

	DARRAY<HWND>		buttons;				//List of user-buttons, in order of addition
	HWND			toolTip;				//Tooltip-control (for this viewer)
	static WNDPROC		orig_ttip_proc;				//Tooltip original window-proc
	static WNDPROC		orig_wnd_proc;				//SoWinViewer original window-proc
        static LRESULT CALLBACK own_wnd_proc(HWND,UINT,WPARAM,LPARAM);
	static LRESULT CALLBACK own_ttip_proc(HWND,UINT,WPARAM,LPARAM);
	};


#else
//X/UNIX:
#include <Inventor/Xt/viewers/SoXtPlaneViewer.h>
#include <Inventor/Xt/viewers/SoXtExaminerViewer.h>
#include <Inventor/Xt/SoXt.h>

class	SoUIExaminerViewer : public SoXtExaminerViewer, public UIViewerBase
	{
	public:

	static void		initialize();				//Initializes class with OS-specific info		

	protected:
	
	//TO_DO: Add here the required methods please for the Xt implementation
	};

#endif


// Define the macros MAKE_CURRENT and SWAP_BUFFERS having an Inventor viewer as argument. 
// These call platform-specific code. Once they are perfected we could make them functions
// instead of macros.

#ifdef WIN32
#define MAKE_CURRENT(vi) wglMakeCurrent(vi->getNormalDC(),vi->getNormalContext())
#define SWAP_BUFFERS(vi) SwapBuffers(vi->getNormalDC())
#else
#define MAKE_CURRENT(vi) glXMakeCurrent(SoXt::getDisplay(),vi->getNormalWindow(),vi->getNormalContext())
#define SWAP_BUFFERS(vi) glXSwapBuffers(SoXt::getDisplay(),vi->getNormalWindow())
#endif

// Define the macro IV_USES_RGBA if the color byte ordering of the Inventor/Coin3D version we use
// is using RGBA byte ordering. Otherwise we assume Inventor uses ABGR byte ordering. Testing is
// done as follows: Inventor 2.1 and higher and Coin3d use RGBA, Inventor < 2.1 uses ABGR.

#if defined(COIN_VERSION) || defined (SO_VERSION)
#define IV_USES_RGBA
#else
#undef IV_USES_RGBA
#endif


#endif

