#include "GraphManager.h"
#include "GUIManager.h"
#include <iostream.h>
#include "utils.h"
#include "PathQualifier.h"
#include <stdio.h>




void main(int argc,char* argv[])
{
  GraphManager::init();			        //initialize the core of the system

  STRING s = PathQualifier::cannonical(argv[0]);//make a Tcl-type rep of the exec path+filename        

  char* p = strrchr(s,'/');                     //obtain exec-path. Do it without invoking PathQualifier,
  if (p) *p = '\0';                             //since Tcl is not yet initialized

  PathQualifier::addSystemPath(s);              //add the exec's path as system-path for qualification

  GUIManager::init();			        //initialize the Tcl and GUI stuff

  if (argc>1)	                                //execute any Tcl script given as cmdline arg
  {
     STRING s = PathQualifier::cannonical(argv[1]);  //xform arg to Tcl-type rep
     STRING q = "pr_read_tcl "; q += addQuotes(s);   //load script via pr_read_tcl, for qualification
     GUIManager::exec(q);
  }
  
  GUIManager::mainLoop();		        //start event loop
}



